function [wrisk_a,agscore_a]=calc_oos(ens,experiments,nmout,fields_std,pcat_us,nn_exp_us,plfac)

for f=1:2
for j=1:numel(nmout)
for ex=1:numel(experiments)
      try
   ptype=fieldnames(ens.(experiments{ex}).(nmout{j}));
   itype=fieldnames(ens.(experiments{ex}).(nmout{j}).(ptype{1}));
   rtype=fieldnames(ens.(experiments{ex}).(nmout{j}).(ptype{1}).(itype{1}));
   fld(:,:,:,j,f,ex)=ens.(experiments{ex}).(nmout{j}).(ptype{1}).(itype{1}).(rtype{1}).(fields_std{f});
     catch
      fld(:,:,:,j,f,ex)=NaN;
    end
 end
end
end


for f=1:2
  dfld(:,:,:,f)=squeeze(mean(fld(:,:,:,:,f,2)-fld(:,:,:,:,f,1),3));
end

gpall=find(~isnan(squeeze(mean(mean(mean(mean(mean(fld(34,34,1,:,:,:),1),2),3),5),6))));

agscore=NaN(numel(nmout),2);
rrisk=NaN(numel(nmout),2);
wrisk=NaN(numel(nmout),2);


for j=1:numel(gpall)
    gpair=[gpall(1:(j-1));gpall(j+1:end)];
    
    %%Find distance from actual obs to best model    
    bestposs=min(pcat_us(2:end,1));
    %%now take out models closer than that to the perfect model
    [duf remdist]=find(pcat_us(1+gpall(j),1+gpair)>(bestposs*.9));
    gpres=gpair(remdist);
    
    %%  gpres now excludes near neighbors
uwgt_tmp=NaN(numel(nmout),1);
uwgt_tmp(gpres)=sum(exp(-(pcat_us(1+gpres,1+gpres)/mean(nn_exp_us)).^2)).^-1;
uwgt_tmp=uwgt_tmp./nanmean(uwgt_tmp);

scrcat_tmp=NaN(numel(nmout),1);
scrcat_tmp(gpres)=pcat_us(1+gpres,1+gpall(j))./mean(pcat_us(1+gpres,1+gpall(j)));
swgt_tmp=exp(-(scrcat_tmp./min(scrcat_tmp)/plfac).^2);
swgt_tmp=swgt_tmp/nanmean(swgt_tmp);

awgt_tmp=swgt_tmp.*uwgt_tmp;
awgt_tmp=awgt_tmp./nanmean(awgt_tmp);
for f=1:2
    
    %calculate weighted and unweight SSE score
trumap=dfld(:,:,gpall(j),f);
wgtmap=nanmean(repmat(reshape(awgt_tmp,1,1,{}),size(dfld,1), ...
                      size(dfld,2),1).*dfld(:,:,:,f),3);
wgtscore=nansum((wgtmap(:)-trumap(:)).^2);
uwgtmap=nanmean(repmat(reshape(uwgt_tmp,1,1,{}),size(dfld,1), ...
                      size(dfld,2),1).*dfld(:,:,:,f),3);
uwgtscore=nansum((uwgtmap(:)-trumap(:)).^2);
agscore(gpall(j),f)=wgtscore./uwgtscore;

%%calculate fraction of models greater than truth in each gridcell
tmp=sum(dfld(:,:,gpres,f)>repmat(trumap,1,1,numel(gpres)),3)./ ...
    sum(ones(size(dfld(:,:,gpres,f))),3);
%produce histogram
histtmp=hist(tmp(:),10);
histtmp=histtmp/sum(histtmp);

%%calculate weighted fraction of models greater than truth in each
%%gridcell
wgtgrid=repmat(reshape(awgt_tmp(gpres),1,1,{}),size(dfld,1),size(dfld,2),1);
tmp=sum([dfld(:,:,gpres,f)>repmat(trumap,1,1,numel(gpres))].*wgtgrid,3)./ ...
    sum(ones(size(dfld(:,:,gpres,f))),3);
histwgt=hist(tmp(:),10);
histwgt=histwgt./sum(histwgt);

rrisk(gpall(j),f)=max(histtmp([1,10]));
wrisk(gpall(j),f)=max(histwgt([1,10]));

end
end


wrisk_a=nanmean(wrisk);
agscore_a=nanmean(agscore);
