function [awgt_us uwgt_us swgt_us nmout]=calc_weight_easy(inmodel)


    %set skill parameter (fraction of distance from obs to best
    %performing model
    plfac=0.8;
    %set uniqueness parameter (percentile of distance distribution)
    pufac=1.5;
    %read in distance matrix (first row/column is obs)
    distdata=importdata('pcat.txt');
    pcat_us=distdata.data;
    nmout=distdata.colheaders;

if nargin<1
    %if no input, include all models - 
    inmodel=ones(numel(nmout)-1,1);
end
%calculate near neighbour distance from specified percentile parameter
    nn_exp_us=prctile(pcat_us(find(pcat_us(:)>0)),pufac)
    
%calculate uniqueness weight (global)
    tmp1=exp(-(pcat_us(2:end,2:end)/mean(nn_exp_us)).^2);
%adjust for input
    uwgt_us=sum(tmp1.*repmat(inmodel,1,numel(inmodel))).^-1;
    
    %make vector of distances from each model to observations
scrcat_us=pcat_us(2:end,1)./mean(pcat_us(2:end,1));
    %calculate skill weights
swgt_us=exp(-(scrcat_us./min(scrcat_us)/plfac).^2);

%keep only models in 'inmodel'
swgt_us(find(inmodel==0))=0;
    %normalize skill weights
swgt_us=swgt_us/mean(swgt_us);
  
%combined weights
awgt_us=swgt_us.*uwgt_us';


