function [out,oout,owgt,nmout]=makearray(ens,obs,modelnames,usemdl, ...
                                         var,tperiod,rval,wgt,seas,ic)

    %%% format input vector - ens is the CMIP ensemble structure, obs is the
    %%% observational structure, modelnames is the full list of
    %%% input models, and usemdl is the binary vector of which
    %%% models to include in the analysis,  var is the varaible to
    %%% use in the strucutre, tperiod is the experiment name, rval
    %%% is the i/c ensemble simulation name, wgt is the name of the
    %%% area weighting mask in the data structure, seas is the
    %%% season(s) to include and ic is a 0/1 flag to include all
    %%% i/c members for a given model experiment.
    
if nargin<9
  seas=[1:4];
end

if nargin<10
  ic=0;
end


n=0;
for i=1:numel(usemdl)
for j=1:numel(usemdl{i})
for r=1:numel(rval)  
ni=fieldnames(ens.(tperiod).(modelnames{i}).(usemdl{i}{j}));
nr=fieldnames(ens.(tperiod).(modelnames{i}).(usemdl{i}{j}).(ni{1}));

if ~ic
  nr=nr(1);
end

for ri=1:numel(nr)
  n=n+1;
try

var_in=ens.(tperiod).(modelnames{i}).(usemdl{i}{j}).(ni{1}).(nr{ri}).(var);
if size(var_in,3)==4
  var_in=var_in(:,:,seas);
end

  
out(:,n)=var_in(:);
catch
out(:,n)=NaN;
end

if numel(usemdl{i})>1
  nmout{n}=[modelnames{i} '_' usemdl{i}{j}];
else
nmout{n}=[modelnames{i}];
end

if ic
  nmout{n}=[nmout{n} '_' nr{ri}];
end


end
end
end
end
oout=obs.(var).var;
owgt=obs.(var).(wgt);

if size(oout,3)==4
  oout=oout(:,:,seas);
  owgt=owgt(:,:,seas);
end
oout=oout(:);
owgt=owgt(:);