%%  define state save directory
datapar='/project/cmip5/ETH/cmip5/'

%%  which experiments to use?
experiments={'historical','rcp85'}

%%%  what are the past/future date ranges?
strtnum=[datenum('1976-01-01'),datenum('2080-01-01')];
endnum=[datenum('2005-01-01'),datenum('2100-01-01')];
%%  what fields to use (mean state)?
fields={'hur','tas','rlut','rsut','ta','pr','psl'};
%%Define seasons
mnths={[12,1,2],[3,4,5],[6,7,8],[9,10,11]};
%% Which extreme fields to use (precip)
xtrmfld={'rx5day_DJF'  'rx5day_JJA' 'rx5day_MAM'  'rx5day_SON'}
%% Which extreme fields to use (temperature)
wrmfld={ 'tnn' 'tnx'  'txn'  'txx'};
%Define interpolated grid
 pres=1.0e+05 *fliplr([0.0100,     0.0200,     0.0300,     0.0500,     0.0700,     0.1000,     0.1500,     0.2000,     0.2500,     0.3000,     0.4000,     0.5000,     0.6000,     0.7000,     0.8500,     0.9250,     1.0000])
dpres=-diff([pres,0]);
 lats=[-89.5:1:89.5];
 lons=[1:360];

 %%%Define control simulation for significance testing
fields_std={'tas','pr'};
exp_std={'piControl'};
strtstd=[datenum('0100-01-01')];
endstd=[datenum('1000-01-01')];



%%Read data or load structure?
if 0
    %Read control
read_std;
%Read observations
  read_obs;
  %Read CMIP5 ensemble
read_ens;

%save data structure
save([datapar ,'/cmip.mat'],'-v7.3')
else
    %load data structure
  load([datapar ,'/cmip.mat'])
end




clear usemdl mdlname
%CMIP name vector
modelnames=fieldnames(ens.historical);
nn=0;

%find runs with all required data
for i=1:numel(modelnames)
  pp=fieldnames(ens.historical.(modelnames{i}));
  n=0;
  for j=1:numel(pp)
ni=fieldnames(ens.historical.(modelnames{i}).(pp{j}));
nr=fieldnames(ens.historical.(modelnames{i}).(pp{j}).(ni{1}));
nf=numel(fieldnames(ens.historical.(modelnames{i}).(pp{j}).(ni{1}).(nr{1})));
    if nf==15
      n=n+1;
      nn=nn+1;
     usemdl{i}{n}=pp{j};
  end

end
end



%%Sample uniqueness tolerance
uncvec=[0.:0.1:5];
clear unmat
for i=1:numel(uncvec)
    i
        [~,~,~,~,~,~,~,~,~,~,unmat(i,:)]=calc_weights_corr(ens,obs,modelnames, ...
                                              usemdl,1,uncvec(i));
end
%% plot uniqueness senstivity test
plot_uncwgt;

%% calculate demonstration case
         [eumat,esmat,emmat,swgt,swgt_us,scr_seas,scr_us,scr, ...
          scrcat,scrcat_us,uwgt,uwgt_us,clustr,pcat,pcat_us,nmout,find_nn,ff,pdn_us,pdn,nn_exp,nn_exp_us]=calc_weights_corr(ens,obs,modelnames,usemdl,1,1.5);
         
         
         %sample skill tolerance
skillvec=[0.1:0.1:4];

         disp('scanning skill values')
for i=1:numel(skillvec)
    disp(i/numel(skillvec));
        [eumat(i,:),esmat(i,:),emmat(i,:)]=calc_weights_corr(ens,obs,modelnames, ...
                                              usemdl,skillvec(i), ...
                                                          1.5);
end
%Do leave-one-out sensitivity test
for i=1:numel(skillvec)
    i

        [wrisk(i,:),agscore(i,:)]=calc_oos(ens,experiments,nmout,fields_std,pcat_us,nn_exp_us,skillvec(i));
end

[duf a]=min(sum(agscore,2));
skillrad=0.8;

%plot results of sensitivity test
plot_skillwgt

%% calculate demonstration case with selected parameters

         [eumat,esmat,emmat,swgt,swgt_us,scr_seas,scr_us,scr, ...
          scrcat,scrcat_us,uwgt,uwgt_us,clustr,pcat,pcat_us,nmout,find_nn,ff,pdn_us,pdn,nn_exp,nn_exp_us]=calc_weights_corr(ens,obs,modelnames,usemdl,skillrad,1.5);
         
         %draw main plots

plot_grid(pcat_us,['obs',nmout])
plot_remdist(pcat_us,['obs',nmout])

plot_ind_vs_skill
%plot_mds
plot_skill
%plot_global_vs_us
plot_sig(ens_var,ens,nmout,fields_std,experiments,pcat_us, ...
         nn_exp_us,swgt_us,lats,lons)
write_latex
write_pcat
dlmwrite('pcat_mat.txt',pcat_us)


%calc_weight_easy()


%% Sample skill weight sensitivity
scl=[0.1:0.1:2];
for i=1:numel(scl)
         [eumat2,esmat2,emmat2,swgt2,swgt_us2,scr_seas2,scr_us2,scr2, ...
          scrcat2,scrcat_us2,uwgt2,uwgt_us2,clustr2,pcat2,pcat_us2, ...
          nmout2,find_nn2,ff2,pdn_us2,pdn2,nn_exp2,nn_exp_us2]=calc_weights_corr(ens,obs,modelnames,usemdl,scl(i),1.5);
[mntas(i,:) mnpr(i,:)]=mean_change(ens_var,ens,nmout,fields_std, ...
                          experiments,pcat_us2,nn_exp_us2, ...
                        swgt_us2,lats,lons);
[dmap{i} dstd{i} dsign{i}]=plot_sig(ens_var,ens,nmout,fields_std, ...
                                   experiments,pcat_us2,nn_exp_us2, ...
                                    swgt_us2,lats,lons,0);
cfrac(i)=min(find(cumsum(sort(swgt_us2,'descend'))/sum(swgt_us2)>0.9))/numel(swgt_us2);
end

plot_s_test


%% Sample data type sensitivity

for i=1:12
    i
    wgtmet=zeros(1,12);
    wgtmet(i)=1;
         [eumat2,esmat2,emmat2,swgt2,swgt_us2,scr_seas2,scr_us2,scr2, ...
          scrcat2,scrcat_us2,uwgt2,uwgt_us2,clustr2,pcat2,pcat_us2, ...
          nmout2,find_nn2,ff2,pdn_us2,pdn2,nn_exp2,nn_exp_us2]=calc_weights_corr(ens,obs,modelnames,usemdl,scl(i),0.6,wgtmet);
[mettas(i,:) metpr(i,:)]=mean_change(ens_var,ens,nmout,fields_std, ...
                          experiments,pcat_us2,nn_exp_us2, ...
                        swgt_us2,lats,lons);
[metmap{i} metstd{i} metsign{i}]=plot_sig(ens_var,ens,nmout,fields_std, ...
                                   experiments,pcat_us2,nn_exp_us2, ...
                                    swgt_us2,lats,lons,0);
end
