figure(13)
clf
clear axs
subplot(3,1,1)
clear p
for i=1:size(esmat,2)
p(i)=plot(skillvec,esmat(:,i)/min(eumat(:,i)),'color',cols(i,:)/3+[.33,0.33,0.33]*2);
hold on
end
tmp=mean(esmat./repmat(min(eumat),[numel(skillvec),1]),2);;
pfin=plot(skillvec,tmp,'k','linewidth',2);
ylabel({'RMSE score of weighted mean','relative to unweighted'});
xlabel('Skill radius D_s (relative to best performing model)');
l=legend([p,pfin],[ff;'Combined']);
plot([skillrad,skillrad],[0.5,1.5],'k--','linewidth',2)

xlim([0,2]);
ylim([0.5,1.5]);
title('(a)')
axs{1}=gca;
psn{1}=get(gca,'position');

subplot(3,1,2)
clear p
p(1)=plot(skillvec,agscore(:,1),'color',cols(1,:)/3+[.33,0.33, ...
                    0.33]*2);
hold on
p(2)=plot(skillvec,agscore(:,2),'color',cols(2,:)/3+[.33,0.33,0.33]*2);
l=legend([p],{'2080 temperature change','2080 precipitation change'});


plot([skillrad,skillrad],[0.5,1.5],'k--','linewidth',2)


ylabel({'Average perfect model RMSE','relative to unweighted'});
xlabel(['Skill radius D_s (relative to best performing ' ...
        'model)']);
xlim([0,2]);
ylim([0.5,1.5]);
title('(b)')
axs{2}=gca;
psn{2}=get(gca,'position');


subplot(3,1,3)
clear p

p(1)=plot(skillvec,wrisk(:,1),'color',cols(1,:)/3+[.33,0.33,0.33]* ...
          2);
hold on
p(2)=plot(skillvec,wrisk(:,2),'color',cols(2,:)/3+[.33,0.33,0.33]*2);
l=legend([p],{'2080 temperature change','2080 precipitation change'});

ylabel({'Fraction of gridcells with truth','below 10th or above 90th percentile'});
xlabel(['Skill radius D_s (relative to best performing ' ...
        'model)']);
plot([skillrad,skillrad],[0.,.5],'k--','linewidth',2)
title('(c)')
axs{3}=gca;
psn{3}=get(gca,'position');

xlim([0,2]);
ylim([0,.5]);


for i=1:3
    set(axs{i},'position',psn{i}.*[1,1,0.9,1]+[0.1,0,0,0]);
end


            set(gcf, 'PaperPosition', [0 0 4 11]);
	          set(gcf, 'PaperSize', [4 11]);
print(gcf,'-dpdf','-painters',['skillwgt.pdf'])
